﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Carrot.Core.Caching
{
    public class NullCache : ICache
    {

        private static NullCache _instance = new NullCache();

        public static ICache Instance
        {
            get
            {
                return _instance;
            }
        }

        private NullCache()
        { 
        }

        #region ICache Members

        public TObject Get<TKey, TObject>(TKey cacheKey)
        {
            return default(TObject);
        }

        public void Set<TKey, TObject>(TKey cacheKey, TObject cacheObject)
        {
        }

        #endregion
    }
}
